from typing import Optional

import pygame
from pygame import Surface

from physics.TickData import TickData
from sprite.BoundingBox import BoundingBox
from ui_elements.UiElement import UiElement


class ColoredRectangleUiElement(UiElement):

    def __init__(self, width: float, height: float, color: tuple):
        super().__init__()

        self.width = width
        self.height = height
        self.color = color

    def render_sprite_image(self) -> Optional[Surface]:
        bounding_box = self.get_bounding_box()
        background_rect = bounding_box.get_rect()

        surface = pygame.Surface((self.width, self.height), pygame.SRCALPHA)
        pygame.draw.rect(surface, self.color, background_rect)
        return surface

    def get_bounding_box(self) -> BoundingBox:
        return BoundingBox(self.position_scale.position[0], self.position_scale.position[1],
                           self.width, self.height)

    def tick(self, tick_data: TickData):
        pass
